#ifndef _RTP_PACKET_H_
#define _RTP_PACKET_H_

#include "list.hh"
#include "flat.hh"
#include "types.hh"
#include "ssrc.hh"

class RTP_Header : public FlatMemory
{
private:
  struct rtp_fix_header
    {
      unsigned int         type:2;      /* packet type */
      unsigned int         p:1;         /* padding flag */
      unsigned int         x:1;         /* header extension flag */
      unsigned int         cc:4;        /* CSRC count */
      unsigned int         m:1;         /* marker bit */
      unsigned int         pt:7;        /* payload type */
      uint16               seq;         /* sequence number */
      uint32               ts;          /* timestamp */
      uint32               ssrc;        /* synchronization source */
    };
  rtp_fix_header*  header;
public:
  RTP_Header();
  RTP_Header(FlatMemory&,unsigned int);
  ~RTP_Header();
  //unsigned int  Read(void*,unsigned int,unsigned int);
  //unsigned int  Write(void*,unsigned int,unsigned int);
  unsigned int  Size();
  unsigned int  DataSize();

  unsigned int  Header_size();
  int GetVersion();
  int GetPadding();
  int GetExtension();
  int GetCC();
  int GetMarker();
  int GetPayloadType();
  uint16 GetSequence();
  uint32 GetTimestamp(); 
  SSRC GetSSRC();
  void SetVersion(int);
  void SetPadding(int);
  void SetExtension(int);
  void SetCC(int);
  void SetMarker(int);
  void SetPayloadType(int);
  void SetSequence(uint16);
  void SetTimestamp(uint32); 
  void SetSSRC(SSRC);
};


/*
class RTP_PayLoad
{
private:
  void*   pdata;
public:
  RTP_PayLoad(void*);
  ~RTP_PayLoad();
  int Read(void*,int);
  int Write(void*,int);
};
*/

/*
class RTP_Packet
{
private:
  Buffer*        pbuffer;
public:
  RTP_Header*    prtp_header;
  RTP_PayLoad*   ppayload;
  RTP_Packet(Buffer*);
  ~RTP_Packet();  
};
*/

#endif
